{{ radar_demo.spin - control both PING))) sensor and servo

   14 Aug 2007 - Xander Soldaat
                 Initial version

}}

DAT
  propArr     Byte "-\|/"
 
CON
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 5_000_000
  CACHESIZE     = 16
   
VAR
  long  stack[20]
  byte  semID
  word  map[CACHESIZE]
  
OBJ
  Radar: "radar"
  Debug: "SerialMirror"
  
PUB main | i
  Debug.start(31, 30, 0, 57600)  
  showWaiting
  wordfill(@map, CACHESIZE, 0)
  
  if not radar.start(7, 6, 500, 2250)
    Debug.str(string("Could not start radar object, rebooting in 5 secs", 10, 13))
    waitcnt(clkfreq * 5 + cnt)
    reboot
  radar.reset_servo
  radar.swivel
  repeat while not radar.map_ready
  repeat 3
    radar.copyCache(@map)
    Debug.str(string("map: "))
    repeat i from 0 to CACHESIZE - 1
      Debug.dec(map[i])
      Debug.str(string(" "))
    Debug.str(string(10,13))
    waitcnt(clkfreq * 6 + cnt)
  radar.stop     
  
PRI showWaiting | i  
  repeat i from 0 to 70
    Debug.tx(propArr[i//4])
    waitcnt(clkfreq / 15 + cnt)
    Debug.str(string(27, "[K"))
    Debug.str(string(27, "[0;0H"))  